<%@ page import="com.opencms.core.*,java.util.*,com.opencms.flex.jsp.*,com.opencms.file.*,java.io.*" %><%! 

	public String replace(String value) {
        StringBuffer ret = new StringBuffer();
        for(int i = 0; i < value.length(); i++) {
            if(value.charAt(i) == '\n') {
                ret.append("\\n");
            } else {
                ret.append(value.charAt(i));
            }
        }
        return ret.toString();
	}

%><%
	 
 	// Create a JSP action element
 	com.opencms.flex.jsp.CmsJspActionElement cms = new CmsJspActionElement(pageContext, request, response);
 	
 	// Check for template property
 	String template = cms.property("template", "search", "undefined") + ".jsp";
	HashMap map;	
	
	// File name semi-constants
	String originalBundle = "com/opencms/workplace/workplace.properties";

    // Get the current file and folder name
    String filename = cms.getCmsObject().getRequestContext().getUri();
    String foldername = com.opencms.file.CmsFile.getPath(filename);
    
    String inputBundle = cms.property("target", "parent", "new.properties");
	if (! inputBundle.startsWith("/")) {
		inputBundle = foldername + inputBundle;
	}

 	// Include template head	 	
 	cms.include(template, "head");
	
	byte[] contents = "error".getBytes();
	try {
		CmsFile file = cms.getCmsObject().readFile(inputBundle);
		contents = file.getContents();
	} catch (Exception e) {
		out.println("<h3>" + e + "</h3>");
	}
			
	// Get the current file and folder name
	ByteArrayInputStream inStream = new ByteArrayInputStream(contents);
	Properties newMessages = new Properties();
	newMessages.load(inStream);
	
	boolean combineMissing = "true".equals(request.getParameter("combine"));
	boolean hideMatching = "true".equals(request.getParameter("hideMatching"));
	boolean hideMissing = "true".equals(request.getParameter("hideMissing"));	
	boolean hideNew = "true".equals(request.getParameter("hideNew"));

	// Now get a CmsMessages object with all keys from the workplace:	
	Properties originalMessages = new Properties();
	try {
		originalMessages.load(getClass().getClassLoader().getResourceAsStream(originalBundle));
	} catch(Exception e) {}
    
	String[] magicKeys = { "version", "name", "content-encoding" };
	List magicKeyList = Arrays.asList(magicKeys);
		           
    Enumeration keys;
    
    keys = newMessages.keys();
	ArrayList newList = new ArrayList();
	while (keys.hasMoreElements()) {		
		String key = (String)keys.nextElement();
		if (magicKeyList.indexOf(key) < 0) newList.add(key);
		String value = replace((String)newMessages.get(key));
		newMessages.put(key, value);		
	}

    keys = originalMessages.keys();
	ArrayList originalList = new ArrayList();
	while (keys.hasMoreElements()) {		
		String key = (String)keys.nextElement();
		if (magicKeyList.indexOf(key) < 0) originalList.add(key);
		String value = replace((String)originalMessages.get(key));
		originalMessages.put(key, value);		
	}
	Collections.sort(originalList);	
	Collections.sort(newList);	
	
	List missingKeys = new ArrayList();
	List matchingKeys = new ArrayList();
	List unrequiredKeys = new ArrayList();
	
	Iterator i;
	
	i = originalList.iterator();
	while (i.hasNext()) {
		String key = (String)i.next();
		int index = newList.indexOf(key);
		if (index < 0) {
			missingKeys.add(key);
		} else {
			if (! "".equals(((String)newMessages.get(key)).trim())) {
				matchingKeys.add(key);
			} else {
				missingKeys.add(key);
			}
		}
	}
	i = newList.iterator();
	while (i.hasNext()) {
		String key = (String)i.next();
		int index = matchingKeys.indexOf(key);
		if (index < 0) {
			if (! "".equals(((String)newMessages.get(key)).trim())) {
				unrequiredKeys.add(key);
			}	
		}
	}	
		
%>

<% if (matchingKeys.size() > 0) { %>

<h4>Matching keys:
<%
if (hideMatching) {
%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=false&hideNew=<%= hideNew %>&hideMissing=<%= hideMissing %>" >[show]</a><%
} else {
%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=true&hideNew=<%= hideNew %>&hideMissing=<%= hideMissing %>">[hide]</a><%
}
%></h4>
<% if (! hideMatching) {%>
<dl>
<%	
	i = matchingKeys.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
%>
<dt style="color:#006600"><%= key %></dt>
<dd style="color:#660000"><%= com.opencms.util.Encoder.escapeHtml((String)originalMessages.get(key)) %> &nbsp;</dd>
<dd style="color:#000066"><%= com.opencms.util.Encoder.escapeHtml((String)newMessages.get(key)) %> &nbsp;</dd>
<%	} %>
</dl>
<% } %>
<% } %>
<% if (unrequiredKeys.size() > 0) { %>

<h4>Unrequired keys:</h4>
<dl><%		
	i = unrequiredKeys.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
%>
<dt style="color:#006600"><%= key %></dt>
<dd style="color:#000066"><%= com.opencms.util.Encoder.escapeHtml((String)newMessages.get(key)) %></dd>
<%	} %>
</dl>

<% } else { %>
<h4>There are no unrequired keys!</h4>
<p>
This is good.
</p>
<% } %>
<% if (missingKeys.size() > 0) { %>

<h4>Missing keys:
<%
if (hideMissing) {
	%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=<%= hideMatching %>&hideNew=<%= hideNew %>&hideMissing=false" >[show]</a></h4><%
} else {
%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=<%= hideMatching %>&hideNew=<%= hideNew %>&hideMissing=true">[hide]</a><%
	if (combineMissing) {
		%><a href="showresources.jsp?combine=false&hideMatching=<%= hideMatching %>&hideNew=<%= hideNew %>&hideMissing=<%= hideMissing %>">[split view]</a><%

	} else {
		%><a href="showresources.jsp?combine=true&hideMatching=<%= hideMatching %>&hideNew=<%= hideNew %>&hideMissing=<%= hideMissing %>">[combine view]</a><%
	}
%></h4>
<table><tr><td>
<pre style="background-color:#e6ffe6;border:solid;border-width:1px;padding:15px"><%		
	i = missingKeys.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
		%><%= key %>=<% 
		if (combineMissing) {
			out.println(com.opencms.util.Encoder.escapeHtml((String)originalMessages.get(key)));
		} else { 
			out.println(); 
		} 
	} %></pre>
</td><td>
<% if (! combineMissing) { %>
<pre style="background-color:#ffe6e6;border:solid;border-width:1px;padding:15px"><%		
	i = missingKeys.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
%><%= com.opencms.util.Encoder.escapeHtml((String)originalMessages.get(key)) %>
<% } %></pre>
<% } %>
</td></tr></table>

<% 
	} 
} else { %>

<h4>There are no missing keys!</h4>
<p>
This is perfect, it means all keys have been translated.
</p>

<% } %>

<% if (matchingKeys.size() > 0) { %>

<h4>New keys sorted: <%
if (hideNew) {
%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=<%= hideMatching %>&hideNew=false&hideMissing=<%= hideMissing %>" >[show]</a><%
} else {
%><a href="showresources.jsp?combine=<%= combineMissing %>&hideMatching=<%= hideMatching %>&hideNew=true&hideMissing=<%= hideMissing %>">[hide]</a><%
}
%></h4>
<% if (! hideNew) { %>
<pre style="background-color:#eeeeee;border:solid;border-width:1px;padding:15px"><%		
	i = magicKeyList.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
%><%= key %>=<%= com.opencms.util.Encoder.escapeHtml((String)newMessages.get(key)) %>
<%	} %>
<%		
	i = matchingKeys.iterator();	
	while (i.hasNext()) {
		String key = (String)i.next();
%><%= key %>=<%= com.opencms.util.Encoder.escapeHtml((String)newMessages.get(key)) %>
<%	} %></pre>

<% } %>

<% } %>

<%	
	// Include template foot
 	cms.include(template, "foot");		
%>